{$DEFINE GU} {GUS: ak pracujes s Gravisom v pocitaci}
{$DEFINE EG} {EGA: ak pracujes s EGA monitorom a kartou}

{

             P PPPPP                    bbb
             P     P                   b b
             P     P                  b  b
             P     P                  b b              jj
             P    P  r                b b              jj
             PPPPP   rrrr     oooo    bb      oooo
             P       r   r   o  o o   b  b   o  o o    jj
             P       r   r  o    o obbb  bbbo    o o  jjj
             P      r    r  o     oo  b  b  o     oojj  j
             P           r ro     o   bb b  o     o    jjjjj
             P            r  ooooo     bb    ooooo    j j
                                                     j  j
                                                     jjj


            ------------------------------------------------
}

Program Proboj_KSP_97_1;

uses graph, {grafika}
     crt, {crt}
{$IFDEF GUS}
     ultraWav, {praca s WAV subormi (hlasky}
     gusInit, {inicializuje GUSa}
     ultraDrv, {driver GUSa}
{$ENDIF}
     dat_typy, {datove typy}
     hrac1, hrac2, hrac3, hrac4;

const arbiterFarba = 15;
      RAND_SEED = 12345;

{$IFDEF GUS}
      welcomeSound = 'main\starqust.wav';
{$ENDIF}

type typeHrac = record
        inicializujSa:function(cisloHraca:byte):string;
        tahaj:procedure(var panaci:typePanaci; ihrisko:typeIhrisko);
        hlaska:procedure(var subor,text:string);
        body,bodyHlasok:longint;
        id:byte; {identifikacne cislo hraca 1..POCET_HRACOV}
        farba:byte; {farba hraca}
        farbaVlastni:byte; {farba vlastneneho policka}
        meno:string;
     end;

var poradie:array[1..POCET_HRACOV] of byte; {poradie tahov hracov}
    por:integer; {pomocna premenna pre poradie}
    tah:integer; {premenna cisla tahu}
    hra:integer;

    fout:text;
    poctyBodov:array[1..POCET_HRACOV] of word;

    ihrisko:typeIhrisko; {hlavne ihrisko}
    panaci:typePanaci; {vsetci panaci}

    hrac:array[1..POCET_HRACOV] of typeHrac; {procedury...}

{$I grafika}

procedure initProboj;
var i,j:byte;
begin
   for i:=1 to POCET_HRACOV do
   begin
      hrac[i].bodyHlasok := 0;
      hrac[i].body := pocetPanakov;
      hrac[i].id := poradie[i];
      case (poradie[i]) of
         1: begin
               hrac[i].inicializujSa := hrac1.inicializujSa;
               hrac[i].tahaj         := hrac1.tahaj;
               hrac[i].hlaska        := hrac1.hlaska;
               hrac[i].farba         := 14;
               hrac[i].farbaVlastni  := 5;
            end;
         2: begin
               hrac[i].inicializujSa := hrac2.inicializujSa;
               hrac[i].tahaj         := hrac2.tahaj;
               hrac[i].hlaska        := hrac2.hlaska;
               hrac[i].farba         := 12;
               hrac[i].farbaVlastni  := 4;
            end;
         3: begin
               hrac[i].inicializujSa := hrac3.inicializujSa;
               hrac[i].tahaj         := hrac3.tahaj;
               hrac[i].hlaska        := hrac3.hlaska;
               hrac[i].farba         := 10;
               hrac[i].farbaVlastni  := 2;
            end;
         4: begin
               hrac[i].inicializujSa := hrac4.inicializujSa;
               hrac[i].tahaj         := hrac4.tahaj;
               hrac[i].hlaska        := hrac4.hlaska;
               hrac[i].farba         := 9;
               hrac[i].farbaVlastni  := 1;
            end;
      end;
      vypis('Inicializujem hraca '+chr(48+i), arbiterFarba);
      hrac[i].meno := hrac[i].inicializujSa(i);
      vypisBody(i);
   end;
   for i:=1 to velkostIhriska do
      for j:=1 to velkostIhriska do
         ihrisko[i,j] := prazdne;
   randseed := RAND_SEED;
   Randomize;
   for j:=1 to celkovyPocetPanakov do
   begin
      repeat
         panaci[j].x := random(velkostIhriska)+1;
         panaci[j].y := random(velkostIhriska)+1;
      until (ihrisko[panaci[j].x,panaci[j].y] = prazdne);
      panaci[j].koho := ((j-1) div pocetPanakov) + 1;
      panaci[j].smer := 0;
      ihrisko[panaci[j].x,panaci[j].y]:=panaci[j].koho + panakC;
   end;
{
   for j:=1 to pocetPanakov do
   begin
      panaci[j].x := 1;
      panaci[j].y := j;
      panaci[j].koho := 1;
      panaci[j].smer := 0;
   end;
   for j:=1 to pocetPanakov do
   begin
      panaci[pocetPanakov+j].x := velkostIhriska+1-j;
      panaci[pocetPanakov+j].y := 1;
      panaci[pocetPanakov+j].koho := 2;
      panaci[pocetPanakov+j].smer := 0;
   end;
   for j:=1 to pocetPanakov do
   begin
      panaci[2*pocetPanakov+j].x := velkostIhriska;
      panaci[2*pocetPanakov+j].y := velkostIhriska+1-j;
      panaci[2*pocetPanakov+j].koho := 3;
      panaci[2*pocetPanakov+j].smer := 0;
   end;
   for j:=1 to pocetPanakov do
   begin
      panaci[3*pocetPanakov+j].x := j;
      panaci[3*pocetPanakov+j].y := velkostIhriska;
      panaci[3*pocetPanakov+j].koho := 4;
      panaci[3*pocetPanakov+j].smer := 0;
   end;
   for i:=1 to POCET_HRACOV do
   begin
      for j:=1 to pocetPanakov do
      Ihrisko[
         panaci[pocetPanakov*(i-1)+j].x,
         panaci[pocetPanakov*(i-1)+j].y
      ] := panaci[pocetPanakov*(i-1)+j].koho + panakC;
   end;
}
end;

procedure vyratajBody(cislo:byte);
var i,j:byte;
begin
   hrac[cislo].body:=0;
   for i:=1 to velkostIhriska do
      for j:=1 to velkostIhriska do
         if ((ihrisko[i,j] = panakC+cislo) or
            (ihrisko[i,j] = vlastniC+cislo)) then
         begin
            inc(hrac[cislo].body);
         end;
end;

function FileExists(FileName: String): Boolean;
var F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;
 Reset(F);
 Close(F);
 {$I+}
 FileMode := 2;
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

procedure tahHraca(cislo:byte);
var subor,text:string;
    temp:string;
    dlzkaHlasky:longint;
    fff:file;
    i,j:byte;
    tempPanaci:typePanaci;
    chceIst:typePanaci; {x,y kam chcu ist, smer = pocet}
    pocetChceIst:integer;
    okolo:byte; {pocitam tam kolko panakov je okolo konvertovaneho}
procedure zoznamUpdate(x,y:byte); {da do zoznamu policko, kam chce niekto ist}
var nasiel:boolean;
begin
   j:=1; nasiel:=false;
   while ((j <= pocetChceIst) and (not nasiel)) do
      if ((chceIst[j].x = x) and (chceIst[j].y = y)) then
         nasiel:=true
      else inc(j);
   if nasiel then
   begin
      inc(chceIst[j].smer);
   end else begin
      inc(pocetChceIst);
      chceIst[pocetChceIst].x := x;
      chceIst[pocetChceIst].y := y;
      chceIst[pocetChceIst].smer := 1;
   end;
end;
function jeVPoriadku(x,y:byte):boolean; {vrati, ci je x,y v zozname raz}
var ii,nasiel:byte;
begin
   nasiel:=0;
   for ii:=1 to pocetChceIst do
      if ((chceIst[ii].x = x) and (chceIst[ii].y = y)) then inc(nasiel);
   jeVPoriadku := (nasiel = 1);
end;
begin
   inc(hrac[cislo].bodyHlasok); {akoze dostal moznost novej hlasky}
   str(hrac[cislo].id,temp);
{   vypis('Taha hrac cislo '+temp+': ',arbiterFarba);
   vypis('   Hlaska... ',hrac[cislo].farba);}
   hrac[cislo].hlaska(subor,text);
   if ((subor = '') and (text = '')) then
   begin
     {vlastne nic}
   end else begin
      if (text <> '') and (hrac[cislo].bodyHlasok > 0) then
      begin
         vypis(text, hrac[cislo].farba);
      end;
      if (subor <> '') and (hrac[cislo].bodyHlasok > 0) then
      begin
         subor:='hrac'+chr(hrac[cislo].id+48)+'\'+subor;
         if (fileExists(subor)) then
         begin
            assign(fff, subor);
            reset(fff, 1);
            dlzkaHlasky:=filesize(fff) div 3528;
            close(fff);
            dec(hrac[cislo].bodyHlasok, dlzkaHlasky); {vycerpal si hlasku}
            {$IFDEF GUS}
            playLongWav(cislo,subor);
            {$ENDIF}
         end else begin
            vypis('Subor '+subor+' sa nenasiel', arbiterFarba);
         end;
      end;
   end;
{   vypis('   Tah... ',hrac[cislo].farba);}
   tempPanaci:=panaci;
   hrac[cislo].tahaj(tempPanaci, ihrisko); {aby mi nezmodifikovali inych...}
   pocetChceIst:=0;
   {prvy cyklus zisti ake kolizie sa vyskytuju}
   for i:=1 to celkovyPocetPanakov do
   if (panaci[i].koho = cislo) then
   begin
      case tempPanaci[i].smer of
      stoj:   ;
      hore:   if (panaci[i].y > 1) and
         (ihrisko[panaci[i].x,panaci[i].y-1] <= panakC)
         then zoznamUpdate(panaci[i].x,panaci[i].y-1);
      dole:   if (panaci[i].y < velkostIhriska) and
         (ihrisko[panaci[i].x,panaci[i].y+1] <= panakC)
         then zoznamUpdate(panaci[i].x,panaci[i].y+1);
      vlavo: if (panaci[i].x > 1) and
         (ihrisko[panaci[i].x-1,panaci[i].y] <= panakC)
         then zoznamUpdate(panaci[i].x-1,panaci[i].y);
      vpravo:  if (panaci[i].x < velkostIhriska) and
         (ihrisko[panaci[i].x+1,panaci[i].y] <= panakC)
         then zoznamUpdate(panaci[i].x+1,panaci[i].y);
      end;
   end;
   {druhy cyklus vykona posunutia}
   for i:=1 to celkovyPocetPanakov do
   if ((panaci[i].koho = cislo) and (tempPanaci[i].smer <> 0)) then
   begin
      ihrisko[panaci[i].x,panaci[i].y] :=
         cislo + vlastniC; {patri hracovi cislo cislo}
      kresliPolicko(panaci[i].x,panaci[i].y);
      case tempPanaci[i].smer of
      stoj:   ;
      hore:   if (panaci[i].y > 1) and
         (ihrisko[panaci[i].x,panaci[i].y-1] <= panakC) and
         (jeVPoriadku(panaci[i].x,panaci[i].y-1))
         then dec(panaci[i].y);
      dole:   if (panaci[i].y < velkostIhriska) and
         (ihrisko[panaci[i].x,panaci[i].y+1] <= panakC) and
         (jeVPoriadku(panaci[i].x,panaci[i].y+1))
         then inc(panaci[i].y);
      vlavo: if (panaci[i].x > 1) and
         (ihrisko[panaci[i].x-1,panaci[i].y] <= panakC) and
         (jeVPoriadku(panaci[i].x-1,panaci[i].y))
         then dec(panaci[i].x);
      vpravo:  if (panaci[i].x < velkostIhriska) and
         (ihrisko[panaci[i].x+1,panaci[i].y] <= panakC) and
         (jeVPoriadku(panaci[i].x+1,panaci[i].y))
         then inc(panaci[i].x);
      end;
      ihrisko[panaci[i].x,panaci[i].y] :=
         cislo + panakC; {patri hracovi cislo cislo}
      kresliPolicko(panaci[i].x,panaci[i].y);
      panaci[i].smer:=0; {vynuluje smer...}
   end;
   {treti cyklus zisti a pripravi konverzie}
   for i:=1 to celkovyPocetPanakov do
   if (panaci[i].koho <> cislo) then
   begin
      okolo:=0;
      if (panaci[i].x > 1) and
         (ihrisko[panaci[i].x-1,panaci[i].y] = panakC + cislo)
         then inc(okolo);
      if (panaci[i].x < velkostIhriska) and
         (ihrisko[panaci[i].x+1,panaci[i].y] = panakC + cislo)
         then inc(okolo);
      if (panaci[i].y > 1) and
         (ihrisko[panaci[i].x,panaci[i].y-1] = panakC + cislo)
         then inc(okolo);
      if (panaci[i].y < velkostIhriska) and
         (ihrisko[panaci[i].x,panaci[i].y+1] = panakC + cislo)
         then inc(okolo);
      panaci[i].smer:=okolo; {smer docasne pouzity}
   end;
   {stvrty cyklus spravi konverzie}
   for i:=1 to celkovyPocetPanakov do
   if (panaci[i].koho <> cislo) then
   begin
      if (panaci[i].smer > 1) then
      begin
         panaci[i].koho := cislo;
         ihrisko[panaci[i].x,panaci[i].y] := panakC + cislo;
         kresliPolicko(panaci[i].x,panaci[i].y);
      end;
      panaci[i].smer:=0; {vynuluje smer...}
   end;
   vyratajBody(cislo);
end;

begin

   {$IFDEF GUS}
   initGUS;
   {$ENDIF}

   initGrafika(POCET_HRACOV);

   for hra:=1 to 4 do poctyBodov[hra]:=0;

   {$IFDEF GUS}
{   vypis('Playing welcome sound...', arbiterFarba);}
{   playLongWav(0,welcomeSound);}
   {$ENDIF}

   hra:=1;
   assign(fout,'body.txt');
   rewrite(fout);
   close(fout);

   while (hra < 5) do
   begin {pre rozne poradia}

      case hra of
       1: begin
           poradie[1]:=1;
           poradie[2]:=2;
           poradie[3]:=3;
           poradie[4]:=4;
          end;
       2: begin
           poradie[1]:=3;
           poradie[2]:=4;
           poradie[3]:=1;
           poradie[4]:=2;
          end;
       3: begin
           poradie[1]:=2;
           poradie[2]:=1;
           poradie[3]:=4;
           poradie[4]:=3;
          end;
       4: begin
           poradie[1]:=4;
           poradie[2]:=3;
           poradie[3]:=2;
           poradie[4]:=1;
          end;
      end;

      initProboj;
      kresliIhrisko;
      vypisMena;

      tah:=1;
      while (tah <= POCET_TAHOV) do
      begin

         vypisTahy(tah);
         for por:=1 to POCET_HRACOV do
         begin
            tahHraca(por);
            vypisBody(por);
            if (hrac[por].body = word(velkostIhriska)*velkostIhriska) then
               tah:=POCET_TAHOV; {uz vsetko patri jednemu}
         end;

         inc(tah);
      end;

      for por:=1 to POCET_HRACOV do
      begin
         vyratajBody(por);
         vypisBody(por);
      end;

      for por:=1 to POCET_HRACOV do
      begin
         inc(poctyBodov[poradie[por]],hrac[por].body);
      end;

      assign(fout,'body.txt');
      append(fout);
      writeln(fout, 'Po ', hra, ' hre:');
      for por:=1 to POCET_HRACOV do
      begin
         writeln(fout,'   Hrac c.', por
            , ' ma ', poctyBodov[por]);
      end;
      close(fout);

      vypis('Koniec hry.',arbiterFarba);

      while keypressed do if (readkey = ' ') then;
      if (readkey = ' ') then;

      inc(hra);
   end; {pre rozne poradia}

   closeGrafika;

   for por:=1 to 11 do WriteLn;
   TextColor(14);
   WriteLn('               -=-==-==[۱۲]==-==-=-               ');
   TextColor(15);
   WriteLn('               Proboj jarnho sstredenia KSP 16-22 marec 1997               ');
   TextColor(14);
   WriteLn('               -=-==-==[۱۲]==-==-=-               ');
   TextColor(7);
   WriteLn;

end.
